<?php


namespace App\Controller;


use Doctrine\ORM\EntityManagerInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

/**
 * @Route("/mean-price-for-squared-meter/{year}/{month}", name="mean_price_for_squared_meter")
 */
class MeanPriceForSquaredMeter extends AbstractController
{
    /**
     * Entity Manager
     */
    private $em;
    public function __construct(EntityManagerInterface $em) {
        $this->em = $em;
    }

    public function __invoke(Request $request,$year, $month) {
        $year = 2015;
        $month = 1;
        if($month < 10){
            $month = '0'.$month;
        }
        $query = "SELECT
                    AVG(valeurs_fonciere.valeur_fonciere / valeurs_fonciere.surface_reelle_bati) AS mean_metre_price
                    FROM App:ValeursFonciere AS valeurs_fonciere
                    WHERE TO_CHAR(valeurs_fonciere.date_mutation, 'YYYY') LIKE '{$year}'
                    AND TO_CHAR(valeurs_fonciere.date_mutation, 'MM') LIKE '{$month}'
                    AND valeurs_fonciere.surface_reelle_bati > 0
                    AND valeurs_fonciere.valeur_fonciere > 0";
        $metre_prices = $this->em->createQuery($query)->getResult();
        $metre_prices[0]['mean_metre_price'] = floatval($metre_prices[0]['mean_metre_price']);
        $res = new JsonResponse(
            $metre_prices[0],
            Response::HTTP_OK
        );
        return $res;
    }
}
